package main

import (
	"bytes"
	"fmt"
	"io/ioutil"
	"log"
	"os"
	"strings"

	"github.com/jordan-wright/email"
)

const removeCR = false

func main() {

	fmt.Printf("[+] Reading '%s'\n", os.Args[1])
	rawBody, err := ioutil.ReadFile(os.Args[1])
	if err != nil {
		fmt.Println("[!] Unable to read email")
		log.Fatal(err)
	}

	if removeCR {
		//Remove CR characters
		fmt.Println("[+] Removing carriage returns")
		tmp := string(rawBody)
		tmp = strings.ReplaceAll(tmp, "\r", "")
		rawBody = []byte(tmp)
	}

	rawBodyStream := bytes.NewReader(rawBody)

	fmt.Println("[+] Email details:\n")

	em, err := email.NewEmailFromReader(rawBodyStream) // Parse with @jordanwright's library
	if err != nil {
		fmt.Println("[!] Unable to read email with Jordan's library: ")
		log.Fatal(err)
	}

	fmt.Printf("\tFrom: %s\n\tTo: %s\n\tSubject: %s\n\tHTML size: %d\n\tText size: %d\n", em.From, em.To, em.Subject, len(em.HTML), len(em.Text))

}
